#pragma once
#ifdef WIN32
#include <windows.h>
#else
#include <sys/time.h>
#endif

#include "Ema.h"
#include "TunnelStreamClient.h"

class AppClient : public refinitiv::ema::access::OmmConsumerClient
{
public:

	AppClient();

	virtual ~AppClient();

	void setTunnelStreamClient(TunnelStreamClient&);
	
protected:

	void onRefreshMsg(const refinitiv::ema::access::RefreshMsg&, const refinitiv::ema::access::OmmConsumerEvent&);

	void onUpdateMsg(const refinitiv::ema::access::UpdateMsg&, const refinitiv::ema::access::OmmConsumerEvent&);

	void onStatusMsg(const refinitiv::ema::access::StatusMsg&, const refinitiv::ema::access::OmmConsumerEvent&);
	void onGenericMsg(const refinitiv::ema::access::GenericMsg&, const refinitiv::ema::access::OmmConsumerEvent&);
	void onAckMsg(const refinitiv::ema::access::AckMsg&, const refinitiv::ema::access::OmmConsumerEvent&);

private:
	TunnelStreamClient* _tunnelStreamClient;
	

};