#pragma once

#ifndef __ema_tunnelstreamclient_h_
#define __ema_tunnelstreamclient_h_

#include <iostream>

#ifdef WIN32
#include <windows.h>
#else
#include <sys/time.h>
#endif

#include "Ema.h"


class TunnelStreamClient : public refinitiv::ema::access::OmmConsumerClient
{
	public:

		TunnelStreamClient(
			const refinitiv::ema::access::EmaString&, 
			const refinitiv::ema::access::EmaString&, 
			const refinitiv::ema::access::EmaString&, 
			const refinitiv::ema::access::EmaString&);

		~TunnelStreamClient();

		void setOmmConsumer(refinitiv::ema::access::OmmConsumer&);

		void processLoginRefresh(const refinitiv::ema::access::RefreshMsg&, const refinitiv::ema::access::OmmConsumerEvent&);
		void processLoginStatus(const refinitiv::ema::access::StatusMsg&, const refinitiv::ema::access::OmmConsumerEvent&);
		void processSourceDirectoryRefresh(const refinitiv::ema::access::RefreshMsg&, const refinitiv::ema::access::OmmConsumerEvent&);
		void processSourceDirectoryUpdate(const refinitiv::ema::access::UpdateMsg&, const refinitiv::ema::access::OmmConsumerEvent&);
		void processSourceDirectoryStatus(const refinitiv::ema::access::StatusMsg&, const refinitiv::ema::access::OmmConsumerEvent&);

	protected:

		void onRefreshMsg(const refinitiv::ema::access::RefreshMsg&, const refinitiv::ema::access::OmmConsumerEvent&);

		void onUpdateMsg(const refinitiv::ema::access::UpdateMsg&, const refinitiv::ema::access::OmmConsumerEvent&);

		void onStatusMsg(const refinitiv::ema::access::StatusMsg&, const refinitiv::ema::access::OmmConsumerEvent&);
		void onGenericMsg(const refinitiv::ema::access::GenericMsg&, const refinitiv::ema::access::OmmConsumerEvent&);
		void onAckMsg(const refinitiv::ema::access::AckMsg&, const refinitiv::ema::access::OmmConsumerEvent&);

	private:
		refinitiv::ema::access::OmmConsumer* _pOmmConsumer;

		refinitiv::ema::access::UInt64 _tunnelStreamHandle;
		refinitiv::ema::access::UInt64 _subStreamHandle;
		const refinitiv::ema::access::EmaString& _serviceName;
		const refinitiv::ema::access::EmaString& _rccUserName;
		const refinitiv::ema::access::EmaString& _rccPassword;
		const refinitiv::ema::access::EmaString& _rccPostRIC;
		long _BID;
		long _ASK;
		int _postStreamID;
		int _postID;

		void loginTunnelStream(refinitiv::ema::access::Int32);
		void startTunnelStream();
		void postData();

};
#endif // __ema_tunnelstreamclient_h_